/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code in this file as it was released upon
 * April 1, 2001 and that is NOT a joke!
 *
 * The Initial Developer of the Original Code is HJ van Rantwijk.
 * all Portions created by HJ van Rantwijk are Copyright (C) 2001-2005
 * by HJ van Rantwijk. All Rights Reserved.
 *
 * Contributor(s): 
 *
 *  Huijing Zhou <hj@cip.wiwi.uni-karlsruhe.de>
 *  Raj Bhaskar <r.bhaskar@compserv.gla.ac.uk>
*/

const G_VER             = "1.8";
const G_REVISION        = "d";
const G_MSG             = "GoogleBox v" + G_VER + G_REVISION;
const G_NAME            = "googlebox";

const G_NEED_BUILD      = 2007013100;
const G_NEED_BUILD_4MAC = 2007013100;

const G_CHROME          = "chrome";
const G_PROFILE         = "Profile";

const G_CONTENT      = "content/googlebox/";
const G_SKIN_CLASSIC = "skin/classic/googlebox/";
const G_SKIN_MODERN  = "skin/modern/googlebox/";
const G_LOCALE       = "locale/en-US/googlebox/";
const G_JAR_FILE     = "googlebox.jar";

// var messages = loadResources("install.properties");

const COMNT_1 = "Installation of " + G_MSG;
const COMNT_2 = "The GoogleBox jar file";
const COMNT_3 = "Browser version to old for this version of The GoogleBox: Aborting Installation";
const COMNT_7 = "Warning: installing with self compiled version (BuildID = 0)";

// The GoogleBox installation process is 'multi-user based' by default
var G_CHROME_LOC = G_CHROME;
var G_CHROME_TYPE = DELAYED_CHROME;
var G_CHROME_DIR = getFolder(G_CHROME);
var installTypeMsg = "InstallType: multi-user installation";
// Check for prior installations in the users profile directory
var profileJAR = getFolder(G_PROFILE, G_JAR_FILE);
var priorProfileInstall = File.exists(profileJAR);
// Check for prior installations in the program directory
var chromeJAR = getFolder(G_CHROME, G_JAR_FILE);
var priorChromeInstall = File.exists(chromeJAR);
// Initialize the prior installation flag
var priorInstallation = false;
  // Update the prior installation flag
  if (priorProfileInstall || priorChromeInstall)
    priorInstallation = true;
  // Is this a fresh installation of The GoogleBox?
  if (!priorInstallation) {
    logComment("New " + COMNT_1);
    // Ask if The GoogleBox should be installed in the profile directory, but only for new installations
    // Installing the same add-on, in both the profile and chrome directory, makes one big mess of it!
    if (confirm("Select OK, for a single-user installation\n\nor CANCEL, for a multi-user installation")) {
      installTypeMsg = "InstallType: single-user installation";
      G_CHROME_LOC = G_PROFILE;
      G_CHROME_TYPE = PROFILE_CHROME;
      G_CHROME_DIR = getFolder(G_PROFILE);
    }
    else installTypeMsg = "InstallType: multi-user installation";
  }
  // We end-up here after locating a prior installation in the users profile directory
  // No need for a confirmation, just install The GoogleBox in the profile directory
  else if (priorProfileInstall) {
    installTypeMsg = "InstallType: single-user installation";
    G_CHROME_LOC = G_PROFILE;
    G_CHROME_TYPE = PROFILE_CHROME;
    G_CHROME_DIR = getFolder(G_PROFILE);      
  }
  var err = initInstall(G_MSG, G_NAME, G_VER);
  var platformStr;
  var platformNode;
  var abort = false;

  logComment("initInstall: " + err);
  // Write "InstallType: xxxxx-user installation" in the logfile
  logComment(installTypeMsg);

  if (!err)
    err = "Ok";
  logComment("Initializing installation : " + err);
  // select used platform
  if ("platform" in Install) {
    platformStr = new String(Install.platform);

    if (!platformStr.search(/^Macintosh/))
      platformNode = "mac";
    else if (!platformStr.search(/^Win/))
      platformNode = "win";
    else
      platformNode = "unix";
  }
  else {
    var fOSMac  = getFolder("Mac System");
    var fOSWin  = getFolder("Win System");

    logComment("fOSMac: "  + fOSMac);
    logComment("fOSWin: "  + fOSWin);

    if (fOSMac != null)
      platformNode = "mac";
    else if (fOSWin != null)
      platformNode = "win";
    else
      platformNode = "unix";
  }
  if (buildID < G_NEED_BUILD)
    abort = true;
  if (abort) {
    if (buildID > 0) {
      alert("Aborting this " + COMNT_1 + 
            "\n\nYou need Mozilla {Build ID: " + G_NEED_BUILD + "} for this installation\n" +
            "but you are using Mozilla {Build ID:" + buildID + "} instead.\n" + 
            "Visit www.mozilla.org and install a recent mozilla build!");
      logComment(COMNT_3);
      cancelInstall();
    }
    else { // No BuildID, compiled without env. variable set!
      alert("Warning: BuildID = 0\n" + 
            "This installation might fail befause of this!\n" + 
            "Please read the instructions on this page:\n\n" + 
            "http://www.mozilla.org/build/distribution.html");
      logComment(COMNT_7);
      abort = false; // allow installation anyway
    }
  }
  if (!abort) {
    if (platformNode == "win")
      logComment("Installation started for Win32 platform");
    else 
      logComment("Installation started for a *nix/Mac platform");
    addFile(COMNT_2, G_JAR_FILE, G_CHROME_DIR, "");
    registerChrome(CONTENT | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_JAR_FILE), G_CONTENT );
    registerChrome(SKIN    | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_JAR_FILE), G_SKIN_CLASSIC );
    registerChrome(SKIN    | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_JAR_FILE), G_SKIN_MODERN );
    registerChrome(LOCALE  | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_JAR_FILE), G_LOCALE );

    err = getLastError();

    if (err == SUCCESS)
      err = performInstall();
    else {
      if (err == ACCESS_DENIED) {
        var access = "The user did not grant the required security privilege.";
        logComment(access);
      }
      logComment("Detailed information can be found at: http://multizilla.mozdev.org/xpi/return-codes.html#ret-202");
      cancelInstall(err);
    }
    err = getLastError();
    if (err == SUCCESS || err == REBOOT_NEEDED) {
      var msg = G_MSG + " has been installed successfully: " + err;
      var finish = (err == SUCCESS) ? "\nPlease restart your browser (including QuickLaunch) to continue." :
                                      "\nPlease reboot your system and restart your browser to continue.";
      refreshPlugins();
      alert(msg+finish);
    }
  }
